
/**
 * This class contains a main method that calls methods in the classes you will write.
 * 
 */
public class RunTransactions
{
    static void main()
    {
       Ledger L = new Ledger();

       // Create two new accounts with the given account numbers
       L.addAccount(1234, new SavingsAccount(1234, 20, (float) 0.04));
       L.addAccount(6778, new CreditCard(6778, (float) 0.16, 500));

       Journal J1 = new Journal();
       Journal J2 = new Journal();

       // Transactions consist of an account reference and an amount
       J1.addTransaction(new CustomerTransaction(1234, 20, "deposit on 3/9/2011"));
       J2.addTransaction(new CustomerTransaction(6778, -200, "charge on 4/9/2011"));
       J1.addTransaction(new CustomerTransaction(1234, 50, "deposit on 5/9/2011"));
       J2.addTransaction(new CustomerTransaction(6778, -300, "charge on 6/9/2011"));
       J2.addTransaction(new CustomerTransaction(6778, -300, "charge on 8/9/2011"));
       J1.addTransaction(new CustomerTransaction(1234, -40, "withdrawal on 3/9/2011"));

       // Transactions must contain a "process" method that is called to
       //  actually perform the transaction.
       // A transaction shoould not be allowed if it results in a negative balance.
       J1.process(L);
       J2.process(L);
       
       Journal J3 = new Journal();
       L.calculateInterest(J3);
       J3.process(L);
       L.report();
    }
}
